#ifndef __MAINDLG_HPP__
#define __MAINDLG_HPP__


#include "protocol.h"
#include "tasocket.hpp"  // TAsyncSocket


class TMainDialog : public CDialog
{
    public:
        TMainDialog(CWnd* pParent = NULL);
        virtual ~TMainDialog();

    protected:
        void  UpdateControls();
        void  ReadSocketData();
        static void  ReadSocketData_Completion1(void* pTMainDialog, void* pStruct, int nResult);
        static void  ReadSocketData_Completion2(void* pTMainDialog, void* pStruct, int nResult);

        void  ProcessMessage(char chMessage, CompletionFn pfnCompletion, void* pRefCon1, void* pRefCon2);
        static void  ProcessMessage_Completion(void* pTMainDialog, void* pStruct, int nResult);
        
        void  ProcessPixelMessage(CompletionFn pfnCompletion, void* pRefCon1, void* pRefCon2);
        static void  ProcessPixelMessage_Completion(void* pTMainDialog, void* pStruct, int nResult);

        void  ProcessLineMessage(CompletionFn pfnCompletion, void* pRefCon1, void* pRefCon2);
        static void  ProcessLineMessage_Completion(void* pTMainDialog, void* pStruct, int nResult);
        
        BOOL  TransmitDoneMessage(CompletionFn pfnCompletion, void* pRefCon1, void* pRefCon2);
        static void  TransmitDoneMessage_Completion(void* pTMainDialog, void* pStruct, int nResult);
        
        BOOL  TransmitPixelMessage(LPPIXEL_DATA lpData, CompletionFn pfnCompletion, void* pRefCon1, void* pRefCon2);
        static void  TransmitPixelMessage_Completion1(void* pTMainDialog, void* pStruct, int nResult);
        static void  TransmitPixelMessage_Completion2(void* pTMainDialog, void* pStruct, int nResult);

        BOOL  TransmitLineMessage(LPLINE_DATA lpData, CompletionFn pfnCompletion, void* pRefCon1, void* pRefCon2);
        static void  TransmitLineMessage_Completion1(void* pTMainDialog, void* pStruct, int nResult);
        static void  TransmitLineMessage_Completion2(void* pTMainDialog, void* pStruct, int nResult);

        static void  DoNothing_Completion(void* pTMainDialog, void* pUnused, int nResult);
        static void  OnClicked_Close_Completion(void* pTMainDialog, void* pUnused, int nResult);

    protected:
        virtual BOOL  OnInitDialog();
        virtual void  OnOK();
        virtual void  OnCancel();
    
    protected:
        afx_msg void  OnClose();
        afx_msg void  OnLButtonDown(UINT nFlags, CPoint point);
        afx_msg void  OnLButtonUp(UINT nFlags, CPoint point);
        afx_msg void  OnMouseMove(UINT nFlags, CPoint point);
        afx_msg void  OnRButtonDown(UINT nFlags, CPoint point);
        afx_msg void  OnClicked_Connect();
        afx_msg void  OnClicked_Listen();
        afx_msg void  OnClicked_Close();
        afx_msg LONG  OnSocketConnect(WPARAM wParam, LPARAM lParam);
        afx_msg LONG  OnSocketClosed(WPARAM wParam, LPARAM lParam);
        afx_msg LONG  OnSocketError(WPARAM wParam, LPARAM lParam);
        DECLARE_MESSAGE_MAP()
        
    protected:
        BOOL          m_bConnected;
        BOOL          m_bDrawingSide;
        TAsyncSocket  m_CommunicationSocket;
        
        BOOL          m_bCaptured;
        COLORREF      m_DrawColor;
        BOOL          m_bIsLine;
        CPoint        m_ptDown;
        CPoint        m_ptPrevious;
};  // TMainDialog


#endif  // __MAINDLG_HPP__
