#ifndef __MAINDLG_HPP__
#define __MAINDLG_HPP__


#include "protocol.h"
#include "tssocket.hpp"  // TSyncSocket


class TMainDialog : public CDialog
{
    public:
        TMainDialog(CWnd* pParent = NULL);
        virtual ~TMainDialog();

    protected:
        void  UpdateControls();
        void  ReadSocketData();
        BOOL  ProcessMessage(char chMessage);
        BOOL  ProcessPixelMessage();
        BOOL  ProcessLineMessage();
        BOOL  TransmitDoneMessage();
        BOOL  TransmitPixelMessage(LPPIXEL_DATA lpData);
        BOOL  TransmitLineMessage(LPLINE_DATA lpData);

    protected:
        virtual BOOL  OnInitDialog();
        virtual void  OnOK();
        virtual void  OnCancel();
    
    protected:
        afx_msg void  OnClose();
        afx_msg void  OnLButtonDown(UINT nFlags, CPoint point);
        afx_msg void  OnLButtonUp(UINT nFlags, CPoint point);
        afx_msg void  OnMouseMove(UINT nFlags, CPoint point);
        afx_msg void  OnRButtonDown(UINT nFlags, CPoint point);
        afx_msg void  OnClicked_Connect();
        afx_msg void  OnClicked_Listen();
        afx_msg void  OnClicked_Close();
        afx_msg LONG  OnSocketNotification(WPARAM wParam, LPARAM lParam);
        DECLARE_MESSAGE_MAP()
        
    protected:
        BOOL         m_bConnected;
        BOOL         m_bDrawingSide;
        TSyncSocket  m_CommunicationSocket;
        
        BOOL         m_bCaptured;
        COLORREF     m_DrawColor;
        BOOL         m_bLine;
        CPoint       m_ptDown;
        CPoint       m_ptPrevious;
};  // TMainDialog


#endif  // __MAINDLG_HPP__
