#ifndef __TSSOCKET_HPP__
#define __TSSOCKET_HPP__


// if an error occurs, TSyncSocket will first call Close()
//   and then post a message to the notification window with
//   WPARAM = GetLastError() and LPARAM = this (a pointer to
//   the TSyncSocket)


class TSyncSocket : public CSocket
{
    public:
        TSyncSocket();
        virtual ~TSyncSocket();
        
        void         SetNotification(CWnd* pWindowToNotify, UINT unNotificationMessage);
        virtual int  Receive(void FAR* lpBuf, int nBufLen, int nFlags = 0);

    protected:
        virtual void  OnClose(int nErrorCode);

    #ifdef _DEBUG
    protected:
        virtual void  AssertValid() const;
    #endif  // _DEBUG
        
    protected:
        // socket owner information
        CWnd*  m_pWindowToNotify;
        UINT   m_unNotificationMessage;

    private:
        // disable use of copy constructor or operator=
        TSyncSocket(const TSyncSocket&);
        void operator=(const TSyncSocket&);
};  // TSyncSocket


#endif  // __TSSOCKET_HPP__
